Bug 520460 - Review Request: perl-POE-Component-Pluggable - A base class for creating plugin-enabled POE components
Summary: Review Request: perl-POE-Component-Pluggable - A base class for creating plug...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
low
medium
Target Milestone: ---
Assignee: Michal Schmidt
QA Contact: Fedora Extras Quality Assurance
URL: http://search.cpan.org/dist/POE-Compo...
Whiteboard:
Depends On:
Blocks: 520431
TreeView+ depends on / blocked
 
Reported: 2009-08-31 15:14 UTC by Chris Weyl
Modified: 2009-09-17 03:31 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-09-17 03:31:33 UTC
mschmidt: fedora-review+
tibbs: fedora-cvs+


Attachments (Terms of Use)

Description Chris Weyl 2009-08-31 15:14:00 UTC
Spec URL: http://fedorapeople.org/~cweyl/review/perl-POE-Component-Pluggable.spec
SRPM URL: http://fedorapeople.org/~cweyl/review/perl-POE-Component-Pluggable-1.24-1.fc11.src.rpm

Description:
POE::Component::Pluggable is a base class for creating plugin enabled
POE Components. It is a generic port of POE::Component::IRC's plugin
system. If your component dispatches events to registered POE sessions,
then POE::Component::Pluggable may be a good fit for you.

Koji build: http://koji.fedoraproject.org/koji/taskinfo?taskID=1645911

*rt-0.10

Comment 1 Michal Schmidt 2009-09-01 13:32:52 UTC
I used cpanspec (recommended by http://fedoraproject.org/wiki/Packaging:Perl)
to verify I'd get something similar to your spec file. There were only two
non-trivial differences:
 - Your specfile has: %{?perl_default_filter} - I did not find it mentioned in
   the guidelines, but I found some BZs explaining it and I believe it is
   correct.
 - My generated specfile has:  Requires: perl(Task::Weaken)
   Perhaps you should add it? Or explain to me why it should not be there.

Review Guidelines check:
( [✓] means OK; [-] means irrelevant; No problems were found.)

[✓] rpmlint must be run on every package. The output should be posted in the
    review.
      perl-POE-Component-Pluggable.src: I: checking
      perl-POE-Component-Pluggable.noarch: I: checking
      2 packages and 0 specfiles checked; 0 errors, 0 warnings.
[✓] The package must be named according to the Package Naming Guidelines.
[✓] The spec file name must match the base package %{name}, in the format
    %{name}.spec unless your package has an exemption.
[✓] The package must meet the Packaging Guidelines.
      I checked http://fedoraproject.org/wiki/Packaging/Guidelines and
      http://fedoraproject.org/wiki/Packaging:Perl and found no problems.
[✓] The package must be licensed with a Fedora approved license and meet the
    Licensing Guidelines.
[✓] The License field in the package spec file must match the actual license.
      GPL+ or Artistic
[✓] If (and only if) the source package includes the text of the license(s) in
    its own file, then that file, containing the text of the license(s) for
    the package must be included in %doc.
[✓] The spec file must be written in American English.
[✓] The spec file for the package MUST be legible.
[✓] The sources used to build the package must match the upstream source, as
    provided in the spec URL. Reviewers should use md5sum for this task. If no
    upstream URL can be specified for this package, please see the Source URL
    Guidelines for how to deal with this.
    sha256sum 99610245e893b59f8096a9fddaef55f3bf79cba2afc171c9b958ae75acfb2018
[✓] The package MUST successfully compile and build into binary rpms on at
    least one primary architecture.
[-] If the package does not successfully compile, build or work on an
    architecture, then those architectures should be listed in the spec in
    ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed
    in bugzilla, describing the reason that the package does not
    compile/build/work on that architecture. The bug number MUST be placed in
    a comment, next to the corresponding ExcludeArch line.
[✓] All build dependencies must be listed in BuildRequires, except for any
    that are listed in the exceptions section of the Packaging Guidelines ;
    inclusion of those as BuildRequires is optional. Apply common sense.
[-] The spec file MUST handle locales properly. This is done by using the
    %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[-] Every binary RPM package (or subpackage) which stores shared library files
    (not just symlinks) in any of the dynamic linker's default paths, must call
    ldconfig in %post and %postun.
[-] If the package is designed to be relocatable, the packager must state this
    fact in the request for review, along with the rationalization for
    relocation of that specific package. Without this, use of Prefix: /usr is
    considered a blocker.
[✓] A package must own all directories that it creates. If it does not create
    a directory that it uses, then it should require a package which does
    create that directory.
[✓] A Fedora package must not list a file more than once in the spec file's
    %files listings.
[✓] Permissions on files must be set properly. Executables should be set with
    executable permissions, for example. Every %files section must include a
    %defattr(...) line.
[✓] Each package must have a %clean section, which contains rm -rf %{buildroot}
   (or $RPM_BUILD_ROOT).
[✓] Each package must consistently use macros.
[✓] The package must contain code, or permissable content.
[-] Large documentation files must go in a -doc subpackage. (The definition of
    large is left up to the packager's best judgement, but is not restricted
    to size. Large can refer to either size or quantity).
[✓] If a package includes something as %doc, it must not affect the runtime of
    the application. To summarize: If it is in %doc, the program must run
    properly if it is not present.
[-] Header files must be in a -devel package.
[-] Static libraries must be in a -static package.
[-] Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for
    directory ownership and usability).
[-] If a package contains library files with a suffix (e.g. libfoo.so.1.1),
    then library files that end in .so (without suffix) must go in a -devel
    package.
[-] In the vast majority of cases, devel packages must require the base
    package using a fully versioned dependency:
    Requires: %{name} = %{version}-%{release}
[✓] Packages must NOT contain any .la libtool archives, these must be removed
    in the spec if they are built.
[-] Packages containing GUI applications must include a %{name}.desktop file,
    and that file must be properly installed with desktop-file-install in the
    %install section. If you feel that your packaged GUI application does not
    need a .desktop file, you must put a comment in the spec file with your
    explanation.
[✓] Packages must not own files or directories already owned by other
    packages. The rule of thumb here is that the first package to be installed
    should own the files or directories that other packages may rely upon.
    This means, for example, that no package in Fedora should ever share
    ownership with any of the files or directories owned by the filesystem or
    man package. If you feel that you have a good reason to own a file or
    directory that another package owns, then please present that at package
    review time.
[✓] At the beginning of %install, each package MUST run rm -rf %{buildroot}
    (or $RPM_BUILD_ROOT).
[✓] All filenames in rpm packages must be valid UTF-8.

Summary:
Just solve the 'Requires: perl(Task::Weaken)' issue, please.

Comment 2 Chris Weyl 2009-09-16 00:34:57 UTC
(In reply to comment #1)
> I used cpanspec (recommended by http://fedoraproject.org/wiki/Packaging:Perl)
> to verify I'd get something similar to your spec file. There were only two
> non-trivial differences:
>  - Your specfile has: %{?perl_default_filter} - I did not find it mentioned in
>    the guidelines, but I found some BZs explaining it and I believe it is
>    correct.

The %perl_default_filter is a relatively new innovation: by policy no package is permitted to either provide from or require for anything under %_docdir, yet RPM insists on doing just that....  %perl_default_filter prevents %_docdir dep issues, as well as preventing any shared library provides from creeping in (which doesn't do anything here, as this is a noarch package).

>  - My generated specfile has:  Requires: perl(Task::Weaken)
>    Perhaps you should add it? Or explain to me why it should not be there.

cpanspec adds as Requires deps that the metadata files (typically Makefile.PL) included with the tarball say it should; however long standing convention is to not use these explicit requires and allow the auto dep/prov scripts to take a stab at it.

The scripts don't always do a great job (particularly w.r.t. versioned deps), as the typical way to express dependencies is through included metadata files.  I've been playing with different ways to manage these deps explicly, but as I'm not ready to recommend changes to the guidelines yet... and as such I don't have any explicit Requires in at the moment.

Sound good? :)

Comment 3 Michal Schmidt 2009-09-16 08:23:23 UTC
Thank you for the explanation.
I approve the package.

Comment 4 Chris Weyl 2009-09-16 15:14:44 UTC
New Package CVS Request
=======================
Package Name: perl-POE-Component-Pluggable
Short Description: A base class for creating plugin-enabled POE components
Owners: cweyl
Branches: F-10 F-11 devel
InitialCC: perl-sig

Comment 5 Jason Tibbitts 2009-09-16 21:48:44 UTC
CVS done.

Comment 6 Chris Weyl 2009-09-17 03:31:33 UTC
Thanks for the review! :-)


Note You need to log in before you can comment on or make changes to this bug.